uninstall.sh 14 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://blog.linuxeye.cn
  4. #
  5. # Notes: OneinStack for CentOS/RadHat 6+ Debian 7+ and Ubuntu 12+
  6. #
  7. # Project home page:
  8. # https://oneinstack.com
  9. # https://github.com/lj2007331/oneinstack
  10. export PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
  11. clear
  12. printf "
  13. #######################################################################
  14. # OneinStack for CentOS/RadHat 6+ Debian 7+ and Ubuntu 12+ #
  15. # Uninstall OneinStack #
  16. # For more information please visit https://oneinstack.com #
  17. #######################################################################
  18. "
  19. # Check if user is root
  20. [ $(id -u) != "0" ] && { echo "${CFAILURE}Error: You must be root to run this script${CEND}"; exit 1; }
  21. oneinstack_dir=$(dirname "`readlink -f $0`")
  22. pushd ${oneinstack_dir} > /dev/null
  23. . ./options.conf
  24. . ./include/color.sh
  25. . ./include/get_char.sh
  26. . ./include/check_dir.sh
  27. Usage(){
  28. printf "
  29. Usage: $0 [ ${CMSG}all${CEND} | ${CMSG}web${CEND} | ${CMSG}mysql${CEND} | ${CMSG}postgresql${CEND} | ${CMSG}mongodb${CEND} | ${CMSG}php${CEND} | ${CMSG}hhvm${CEND} | ${CMSG}pureftpd${CEND} | ${CMSG}redis${CEND} | ${CMSG}memcached${CEND} ]
  30. ${CMSG}all${CEND} --->Uninstall All
  31. ${CMSG}web${CEND} --->Uninstall Nginx/Tengine/Apache/Tomcat
  32. ${CMSG}mysql${CEND} --->Uninstall MySQL/MariaDB/Percona/AliSQL
  33. ${CMSG}postgresql${CEND} --->Uninstall PostgreSQL
  34. ${CMSG}mongodb${CEND} --->Uninstall MongoDB
  35. ${CMSG}php${CEND} --->Uninstall PHP
  36. ${CMSG}hhvm${CEND} --->Uninstall HHVM
  37. ${CMSG}pureftpd${CEND} --->Uninstall PureFtpd
  38. ${CMSG}redis${CEND} --->Uninstall Redis
  39. ${CMSG}memcached${CEND} --->Uninstall Memcached
  40. "
  41. }
  42. Uninstall_status() {
  43. while :; do echo
  44. read -p "Do you want to uninstall? [y/n]: " uninstall_yn
  45. echo
  46. if [[ ! ${uninstall_yn} =~ ^[y,n]$ ]]; then
  47. echo "${CWARNING}input error! Please only input 'y' or 'n'${CEND}"
  48. else
  49. break
  50. fi
  51. done
  52. }
  53. Print_Warn() {
  54. echo
  55. echo "${CWARNING}You will uninstall OneinStack, Please backup your configure files and DB data! ${CEND}"
  56. }
  57. Print_web() {
  58. [ -d "${nginx_install_dir}" ] && echo "${nginx_install_dir}"
  59. [ -d "${tengine_install_dir}" ] && echo "${tengine_install_dir}"
  60. [ -d "${openresty_install_dir}" ] && echo "${openresty_install_dir}"
  61. [ -e "/etc/init.d/nginx" ] && echo '/etc/init.d/nginx'
  62. [ -e "/etc/logrotate.d/nginx" ] && echo '/etc/logrotate.d/nginx'
  63. [ -d "${apache_install_dir}" ] && echo "${apache_install_dir}"
  64. [ -e "/etc/init.d/httpd" ] && echo "/etc/init.d/httpd"
  65. [ -e "/etc/logrotate.d/apache" ] && echo "/etc/logrotate.d/apache"
  66. [ -d "${tomcat_install_dir}" ] && echo "${tomcat_install_dir}"
  67. [ -e "/etc/init.d/tomcat" ] && echo "/etc/init.d/tomcat"
  68. [ -e "/etc/logrotate.d/tomcat" ] && echo "/etc/logrotate.d/tomcat"
  69. [ -d "/usr/java" ] && echo '/usr/java'
  70. [ -d "/usr/local/apr" ] && echo '/usr/local/apr'
  71. }
  72. Uninstall_Web() {
  73. [ -d "${nginx_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${nginx_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${nginx_install_dir}/sbin:@@" /etc/profile; }
  74. [ -d "${tengine_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${tengine_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${tengine_install_dir}/sbin:@@" /etc/profile; }
  75. [ -d "${openresty_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${openresty_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${openresty_install_dir}/nginx/sbin:@@" /etc/profile; }
  76. [ -d "${apache_install_dir}" ] && { service httpd stop > /dev/null 2>&1; rm -rf ${apache_install_dir} /etc/init.d/httpd /etc/logrotate.d/apache; sed -i "s@${apache_install_dir}/bin:@@" /etc/profile; }
  77. [ -d "${tomcat_install_dir}" ] && { killall java > /dev/null 2>&1; chmod +x /etc/logrotate.d/tomcat; rm -rf ${tomcat_install_dir} /etc/init.d/tomcat /etc/logrotate.d/tomcat /usr/local/apr; }
  78. [ -d "/usr/java" ] && { rm -rf /usr/java; sed -i '/export JAVA_HOME=/d' /etc/profile; sed -i '/export CLASSPATH=/d' /etc/profile; sed -i 's@\$JAVA_HOME/bin:@@' /etc/profile; }
  79. [ -e "${wwwroot_dir}" ] && /bin/mv ${wwwroot_dir}{,$(date +%Y%m%d%H)}
  80. sed -i 's@^website_name=.*@website_name=@' ./options.conf
  81. sed -i 's@^local_bankup_yn=.*@local_bankup_yn=y@' ./options.conf
  82. sed -i 's@^remote_bankup_yn=.*@remote_bankup_yn=n@' ./options.conf
  83. echo "${CMSG}Web uninstall completed${CEND}"
  84. }
  85. Print_MySQL() {
  86. [ -e "${db_install_dir}" ] && echo "${db_install_dir}"
  87. [ -e "/etc/init.d/mysqld" ] && echo "/etc/init.d/mysqld"
  88. [ -e "/etc/my.cnf" ] && echo "/etc/my.cnf"
  89. }
  90. Print_PostgreSQL() {
  91. [ -e "${pgsql_install_dir}" ] && echo "${pgsql_install_dir}"
  92. [ -e "/etc/init.d/postgresql" ] && echo "/etc/init.d/postgresql"
  93. }
  94. Print_MongoDB() {
  95. [ -e "${mongo_install_dir}" ] && echo "${mongo_install_dir}"
  96. [ -e "/etc/init.d/mongod" ] && echo "/etc/init.d/mongod"
  97. [ -e "/etc/mongod.conf" ] && echo "/etc/mongod.conf"
  98. }
  99. Uninstall_MySQL() {
  100. # uninstall mysql,mariadb,percona,alisql
  101. if [ -d "${db_install_dir}/support-files" ]; then
  102. service mysqld stop > /dev/null 2>&1
  103. rm -rf ${db_install_dir} /etc/init.d/mysqld /etc/my.cnf /etc/ld.so.conf.d/{mysql,mariadb,percona,alisql}*.conf
  104. id -u mysql >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel mysql
  105. [ -e "${db_data_dir}" ] && /bin/mv ${db_data_dir}{,$(date +%Y%m%d%H)}
  106. sed -i 's@^dbrootpwd=.*@dbrootpwd=@' ./options.conf
  107. sed -i "s@${db_install_dir}/bin:@@" /etc/profile
  108. else
  109. echo "${CWARNING}MySQL already uninstalled! ${CEND}"
  110. fi
  111. }
  112. Uninstall_PostgreSQL() {
  113. # uninstall postgresql
  114. if [ -e "${pgsql_install_dir}/bin/psql" ]; then
  115. service postgresql stop > /dev/null 2>&1
  116. rm -rf ${pgsql_install_dir} /etc/init.d/postgresql ${php_install_dir}/etc/php.d/ext-pgsql.ini
  117. id -u postgres >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel postgres
  118. [ -e "${pgsql_data_dir}" ] && /bin/mv ${pgsql_data_dir}{,$(date +%Y%m%d%H)}
  119. sed -i 's@^dbpostgrespwd=.*@dbpostgrespwd=@' ./options.conf
  120. sed -i "s@${pgsql_install_dir}/bin:@@" /etc/profile
  121. echo "${CMSG}PostgreSQL uninstall completed${CEND}"
  122. else
  123. echo "${CWARNING}PostgreSQL already uninstalled! ${CEND}"
  124. fi
  125. }
  126. Uninstall_MongoDB() {
  127. # uninstall mongodb
  128. if [ -e "${mongo_install_dir}/bin/mongo" ]; then
  129. service mongod stop > /dev/null 2>&1
  130. rm -rf ${mongo_install_dir} /etc/mongod.conf /etc/init.d/mongod /tmp/mongo*.sock
  131. id -u mongod > /dev/null 2>&1 ; [ $? -eq 0 ] && userdel mongod
  132. [ -e "${mongo_data_dir}" ] && /bin/mv ${mongo_data_dir}{,$(date +%Y%m%d%H)}
  133. sed -i 's@^dbmongopwd=.*@dbmongopwd=@' ./options.conf
  134. sed -i "s@${mongo_install_dir}/bin:@@" /etc/profile
  135. echo "${CMSG}MongoDB uninstall completed${CEND}"
  136. else
  137. echo "${CWARNING}MongoDB already uninstalled! ${CEND}"
  138. fi
  139. }
  140. Print_PHP() {
  141. [ -e "${php_install_dir}" ] && echo "${php_install_dir}"
  142. [ -e "/etc/init.d/php-fpm" ] && echo "/etc/init.d/php-fpm"
  143. [ -e "/usr/local/imagemagick" ] && echo "/usr/local/imagemagick"
  144. [ -e "/usr/local/graphicsmagick" ] && echo '/usr/local/graphicsmagick'
  145. }
  146. Uninstall_PHP() {
  147. [ -e "${php_install_dir}/bin/phpize" -a -e "${php_install_dir}/etc/php-fpm.conf" ] && { service php-fpm stop > /dev/null 2>&1; rm -rf ${php_install_dir} /etc/init.d/php-fpm; }
  148. [ -e "${php_install_dir}/bin/phpize" -a ! -e "${php_install_dir}/etc/php-fpm.conf" ] && rm -rf ${php_install_dir}
  149. [ -e "/usr/local/imagemagick" ] && rm -rf /usr/local/imagemagick
  150. [ -e "/usr/local/graphicsmagick" ] && rm -rf /usr/local/graphicsmagick
  151. sed -i "s@${php_install_dir}/bin:@@" /etc/profile
  152. echo "${CMSG}PHP uninstall completed${CEND}"
  153. }
  154. Print_HHVM() {
  155. [ -e "/usr/bin/hhvm" ] && echo "/usr/bin/hhvm"
  156. [ -e "/etc/hhvm" ] && echo "/etc/hhvm"
  157. [ -e "/var/log/hhvm" ] && echo "/var/log/hhvm"
  158. [ -e "/etc/supervisord.conf" ] && echo "/etc/supervisord.conf"
  159. [ -e "/etc/init.d/supervisord" ] && echo "/etc/init.d/supervisord"
  160. }
  161. Uninstall_HHVM() {
  162. [ -e "/etc/init.d/supervisord" ] && { service supervisord stop > /dev/null 2>&1; rm -rf /etc/supervisord.conf /etc/init.d/supervisord; }
  163. [ -e "/usr/bin/hhvm" ] && { rpm -e hhvm; rm -rf /etc/hhvm /var/log/hhvm /usr/bin/hhvm; }
  164. echo "${CMSG}HHVM uninstall completed${CEND}"
  165. }
  166. Print_PureFtpd() {
  167. [ -e "${pureftpd_install_dir}" ] && echo "${pureftpd_install_dir}"
  168. [ -e "/etc/init.d/pureftpd" ] && echo "/etc/init.d/pureftpd"
  169. }
  170. Uninstall_PureFtpd() {
  171. [ -e "${pureftpd_install_dir}" ] && { service pureftpd stop > /dev/null 2>&1; rm -rf ${pureftpd_install_dir} /etc/init.d/pureftpd; }
  172. echo "${CMSG}Pureftpd uninstall completed${CEND}"
  173. }
  174. Print_Redis() {
  175. [ -e "$redis_install_dir" ] && echo "$redis_install_dir"
  176. [ -e "/etc/init.d/redis-server" ] && echo "/etc/init.d/redis-server"
  177. }
  178. Uninstall_Redis() {
  179. [ -e "$redis_install_dir" ] && { service redis-server stop > /dev/null 2>&1; rm -rf $redis_install_dir /etc/init.d/redis-server /usr/local/bin/redis-*; }
  180. [ -e "${php_install_dir}/etc/php.d/ext-redis.ini" ] && rm -rf ${php_install_dir}/etc/php.d/ext-redis.ini
  181. echo "${CMSG}Redis uninstall completed${CEND}"
  182. }
  183. Print_Memcached() {
  184. [ -e "${memcached_install_dir}" ] && echo "${memcached_install_dir}"
  185. [ -e "/etc/init.d/memcached" ] && echo "/etc/init.d/memcached"
  186. [ -e "/usr/bin/memcached" ] && echo "/usr/bin/memcached"
  187. }
  188. Uninstall_Memcached() {
  189. [ -e "${memcached_install_dir}" ] && { service memcached stop > /dev/null 2>&1; rm -rf ${memcached_install_dir} /etc/init.d/memcached /usr/bin/memcached; }
  190. [ -e "${php_install_dir}/etc/php.d/ext-memcache.ini" ] && rm -rf ${php_install_dir}/etc/php.d/ext-memcache.ini
  191. [ -e "${php_install_dir}/etc/php.d/ext-memcached.ini" ] && rm -rf ${php_install_dir}/etc/php.d/ext-memcached.ini
  192. echo "${CMSG}Memcached uninstall completed${CEND}"
  193. }
  194. Print_curlopenssl() {
  195. [ -e "/usr/local/bin/curl" ] && echo "/usr/local/bin/curl"
  196. [ -d "${openssl_install_dir}" ] && echo "${openssl_install_dir}"
  197. }
  198. Uninstall_curlopenssl() {
  199. [ -e "/usr/local/bin/curl" ] && rm -rf /usr/local/lib/libcurl* /usr/local/bin/curl
  200. [ -d "${openssl_install_dir}" ] && { rm -rf ${openssl_install_dir} /etc/ld.so.conf.d/openssl.conf; ldconfig; }
  201. }
  202. Menu(){
  203. while :; do
  204. printf "
  205. What Are You Doing?
  206. \t${CMSG}0${CEND}. Uninstall All
  207. \t${CMSG}1${CEND}. Uninstall Nginx/Tengine/Apache/Tomcat
  208. \t${CMSG}2${CEND}. Uninstall MySQL/MariaDB/Percona/AliSQL
  209. \t${CMSG}3${CEND}. Uninstall PostgreSQL
  210. \t${CMSG}4${CEND}. Uninstall MongoDB
  211. \t${CMSG}5${CEND}. Uninstall PHP
  212. \t${CMSG}6${CEND}. Uninstall HHVM
  213. \t${CMSG}7${CEND}. Uninstall PureFtpd
  214. \t${CMSG}8${CEND}. Uninstall Redis
  215. \t${CMSG}9${CEND}. Uninstall Memcached
  216. \t${CMSG}q${CEND}. Exit
  217. "
  218. echo
  219. read -p "Please input the correct option: " Number
  220. if [[ ! $Number =~ ^[0-9,q]$ ]]; then
  221. echo "${CWARNING}input error! Please only input 0~9 and q${CEND}"
  222. else
  223. case "$Number" in
  224. 0)
  225. Print_Warn
  226. Print_web
  227. Print_MySQL
  228. Print_PostgreSQL
  229. Print_MongoDB
  230. Print_PHP
  231. Print_HHVM
  232. Print_PureFtpd
  233. Print_Redis
  234. Print_Memcached
  235. Print_curlopenssl
  236. Uninstall_status
  237. if [ "${uninstall_yn}" == 'y' ]; then
  238. Uninstall_Web
  239. Uninstall_MySQL
  240. Uninstall_PostgreSQL
  241. Uninstall_MongoDB
  242. Uninstall_PHP
  243. Uninstall_HHVM
  244. Uninstall_PureFtpd
  245. Uninstall_Redis
  246. Uninstall_Memcached
  247. Uninstall_curlopenssl
  248. else
  249. exit
  250. fi
  251. ;;
  252. 1)
  253. Print_Warn
  254. Print_web
  255. Uninstall_status
  256. [ "${uninstall_yn}" == 'y' ] && Uninstall_Web || exit
  257. ;;
  258. 2)
  259. Print_Warn
  260. Print_MySQL
  261. Uninstall_status
  262. [ "${uninstall_yn}" == 'y' ] && Uninstall_MySQL || exit
  263. ;;
  264. 3)
  265. Print_Warn
  266. Print_PostgreSQL
  267. Uninstall_status
  268. [ "${uninstall_yn}" == 'y' ] && Uninstall_PostgreSQL || exit
  269. ;;
  270. 4)
  271. Print_Warn
  272. Print_MongoDB
  273. Uninstall_status
  274. [ "${uninstall_yn}" == 'y' ] && Uninstall_MongoDB || exit
  275. ;;
  276. 5)
  277. Print_PHP
  278. Uninstall_status
  279. [ "${uninstall_yn}" == 'y' ] && Uninstall_PHP || exit
  280. ;;
  281. 6)
  282. Print_HHVM
  283. Uninstall_status
  284. [ "${uninstall_yn}" == 'y' ] && Uninstall_HHVM || exit
  285. ;;
  286. 7)
  287. Print_PureFtpd
  288. Uninstall_status
  289. [ "${uninstall_yn}" == 'y' ] && Uninstall_PureFtpd || exit
  290. ;;
  291. 8)
  292. Print_Redis
  293. Uninstall_status
  294. [ "${uninstall_yn}" == 'y' ] && Uninstall_Redis || exit
  295. ;;
  296. 9)
  297. Print_Memcached
  298. Uninstall_status
  299. [ "${uninstall_yn}" == 'y' ] && Uninstall_Memcached || exit
  300. ;;
  301. q)
  302. exit
  303. ;;
  304. esac
  305. fi
  306. done
  307. }
  308. if [ $# == 0 ]; then
  309. Menu
  310. elif [ $# == 1 ]; then
  311. case $1 in
  312. all)
  313. Print_Warn
  314. Print_web
  315. Print_MySQL
  316. Print_PostgreSQL
  317. Print_MongoDB
  318. Print_PHP
  319. Print_HHVM
  320. Print_PureFtpd
  321. Print_Redis
  322. Print_Memcached
  323. Print_curlopenssl
  324. Uninstall_status
  325. if [ "${uninstall_yn}" == 'y' ]; then
  326. Uninstall_Web
  327. Uninstall_MySQL
  328. Uninstall_PHP
  329. Uninstall_HHVM
  330. Uninstall_PureFtpd
  331. Uninstall_Redis
  332. Uninstall_Memcached
  333. Uninstall_curlopenssl
  334. else
  335. exit
  336. fi
  337. ;;
  338. web)
  339. Print_Warn
  340. Print_web
  341. Uninstall_status
  342. [ "${uninstall_yn}" == 'y' ] && Uninstall_Web || exit
  343. ;;
  344. mysql)
  345. Print_Warn
  346. Print_MySQL
  347. Uninstall_status
  348. [ "${uninstall_yn}" == 'y' ] && Uninstall_MySQL || exit
  349. ;;
  350. postgresql)
  351. Print_Warn
  352. Print_PostgreSQL
  353. Uninstall_status
  354. [ "${uninstall_yn}" == 'y' ] && Uninstall_PostgreSQL || exit
  355. ;;
  356. mongodb)
  357. Print_Warn
  358. Print_MongoDB
  359. Uninstall_status
  360. [ "${uninstall_yn}" == 'y' ] && Uninstall_MongoDB || exit
  361. ;;
  362. php)
  363. Print_PHP
  364. Uninstall_status
  365. [ "${uninstall_yn}" == 'y' ] && Uninstall_PHP || exit
  366. ;;
  367. hhvm)
  368. Print_HHVM
  369. Uninstall_status
  370. [ "${uninstall_yn}" == 'y' ] && Uninstall_HHVM || exit
  371. ;;
  372. pureftpd)
  373. Print_PureFtpd
  374. Uninstall_status
  375. [ "${uninstall_yn}" == 'y' ] && Uninstall_PureFtpd || exit
  376. ;;
  377. redis)
  378. Print_Redis
  379. Uninstall_status
  380. [ "${uninstall_yn}" == 'y' ] && Uninstall_Redis || exit
  381. ;;
  382. memcached)
  383. Print_Memcached
  384. Uninstall_status
  385. [ "${uninstall_yn}" == 'y' ] && Uninstall_Memcached || exit
  386. ;;
  387. *)
  388. Usage
  389. ;;
  390. esac
  391. else
  392. Usage
  393. fi